using System;
using System.Collections.Generic;
using System.Text;

namespace NETSploit
{
    using System;
    using System.Collections.Generic;
    using System.Globalization;

    internal static class CodeUtilities
    {
        public static int calcLineDistance(string line, string nextLine)
        {
            int num = toInt(ParseLineNumber(line));
            return (toInt(ParseLineNumber(nextLine)) - num);
        }

        public static string ExtractLineNumber(string code)
        {
            int index = code.IndexOf("IL_");
            return code.Substring(index, 7);
        }

        public static int[] FindAll(string matchStr, string searchedStr, int startPos)
        {
            int item = -1;
            int num2 = 0;
            List<int> list = new List<int>();
            do
            {
                item = searchedStr.IndexOf(matchStr, startPos, StringComparison.Ordinal);
                if (item > -1)
                {
                    startPos = item + 1;
                    num2++;
                    list.Add(item);
                }
            }
            while ((item > -1) && (startPos < searchedStr.Length));
            return list.ToArray();
        }

        public static string GetNextLineNumber(string line, int instructionSize)
        {
            string str = toHex(toInt(ParseLineNumber(line)) + instructionSize);
            string str2 = "";
            for (int i = 0; i < (4 - str.Length); i++)
            {
                str2 = str2 + "0";
            }
            return ("IL_" + str2 + str);
        }

        public static bool isEndLine(string line)
        {
            return (line.IndexOf("}") != -1);
        }

        public static bool isLineOfCode(string line)
        {
            int index = line.IndexOf("IL_");
            if (index == -1)
            {
                return false;
            }
            int num2 = line.IndexOf("//");
            return ((num2 == -1) || (index < num2));
        }

        public static bool isRetLine(string line)
        {
            return (line.IndexOf("ret") != -1);
        }

        public static string ParseLineNumber(string s)
        {
            return s.Remove(0, 3);
        }

        public static string ReplaceLineNumberInCode(string code, int distance)
        {
            string searchedStr = code;
            int[] numArray = FindAll("IL_", searchedStr, 0);
            for (int i = 0; i < numArray.Length; i++)
            {
                string line = searchedStr.Substring(numArray[i], 7);
                string nextLineNumber = GetNextLineNumber(line, distance);
                
                searchedStr = searchedStr.Remove(numArray[i], 7);
                searchedStr = searchedStr.Insert(numArray[i], nextLineNumber);
                 
            }
            return searchedStr;
        }

        public static string ReplaceLineNumberInCodeSingle(string code, string newLineNumber)
        {
            string oldValue = ExtractLineNumber(code);
            return code.Replace(oldValue, newLineNumber);
        }

        public static string toHex(int n)
        {
            return string.Format("{0:x2}", n);
        }

        public static int toInt(string s)
        {
            return int.Parse(s, NumberStyles.AllowHexSpecifier);
        }
    }
}

