using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Xml;


namespace NETSploit
{
    class ParseItemXML
    {
        string description, itemName;
        string assemblyName, assemblyLocation, nativeImageLocation;
        string InjectionMode;
        ArrayList references, functions, injectedpayloads;
        public ArrayList GetRefernces() { return references; }
        public ArrayList GetFunctions() { return functions; }
        public ArrayList GetInjectedPayloads() { return injectedpayloads; }
        public string GetAssemblyName() { return assemblyName; }
        public string GetAssemblyLocation() { return assemblyLocation; }
        public string GetNativeImageLocation() { return nativeImageLocation; }
        public string GetDescription() { return description; }
        public string GetItemName() { return itemName; }

        public string GetInjectionMode() { return InjectionMode; }

        public ParseItemXML(string XMLfile)
        {
            references = new ArrayList();
            functions = new ArrayList();
            injectedpayloads = new ArrayList();
            itemName = XMLfile.Substring(XMLfile.LastIndexOf('\\') + 1, XMLfile.Length - XMLfile.LastIndexOf('\\') - 1);
            ParseFile(XMLfile);
        }

        public void ParseFile(string XMLfile)
        {
            string FileName = "", Location = "";
            int StackSize = 0;
            InjectionMode = ""; //append , replace
            bool BeforeLocation = true;
            XmlTextReader objXmlTextReader = new XmlTextReader(XMLfile);
            string sName = "";
            while (objXmlTextReader.Read())
            {
                switch (objXmlTextReader.NodeType)
                {
                    case XmlNodeType.Element:
                        sName = objXmlTextReader.Name;
                        break;
                    case XmlNodeType.CDATA:
                        Location = objXmlTextReader.Value;
                        break;
                    case XmlNodeType.Text:
                        switch (sName)
                        {
                            case "Description":
                                description = objXmlTextReader.Value;
                                break;
                            case "AssemblyName":
                                assemblyName = objXmlTextReader.Value;
                                break;
                            case "AssemblyLocation":
                                assemblyLocation = objXmlTextReader.Value;
                                break;
                            case "NativeImageLocation":
                                nativeImageLocation = objXmlTextReader.Value;
                                break;
                            case "FileName":
                                FileName = objXmlTextReader.Value;
                                break;
                            case "BeforeLocation":
                                BeforeLocation = objXmlTextReader.Value.Equals("TRUE") ? true : false;
                                break;
                            case "StackSize":
                                StackSize = int.Parse(objXmlTextReader.Value);
                                break;
                            case "InjectionMode":
                                InjectionMode = objXmlTextReader.Value;
                                break;
                        }
                        break;
                    case XmlNodeType.EndElement: 
                        switch (objXmlTextReader.Name)
                        {
                            case "AssemblyRef":
                                references.Add(new PayloadExternalRef("DESC", FileName));
                                break;
                            case "AssemblyFunc":
                                functions.Add(new PayloadFunction("DESC", FileName, Location, BeforeLocation));
                                break;
                            case "AssemblyCode":
                                string mode = InjectionMode.ToUpper();
                                PayloadInjectedCode.InjectionModeEnum modeEnum;
                                if (mode.Equals("REPLACE"))
                                    modeEnum = PayloadInjectedCode.InjectionModeEnum.Replace;
                                else
                                    if (mode.Equals("PRE APPEND"))
                                        modeEnum = PayloadInjectedCode.InjectionModeEnum.PreAppend;
                                else if (mode.Equals("POST APPEND"))
                                    modeEnum = PayloadInjectedCode.InjectionModeEnum.PostAppend;
                                    else //default is post append mode
                                    modeEnum = PayloadInjectedCode.InjectionModeEnum.PostAppend;
                                injectedpayloads.Add(new PayloadInjectedCode("DESC", FileName, Location, StackSize, modeEnum));
                                break;
                        }
                        break;
                }
            }
        }
    }
}

