using System;
using System.Collections.Generic;
using System.Text;

namespace NETSploit
{
    using System;
    using System.Diagnostics;
    using System.IO;

    internal static class FileUtilities
    {
        public static void Decompile(string dllName)
        {
            try
            {
                Process process = new Process();
                process.StartInfo.FileName = Configuration.ildasmLocation;
                process.StartInfo.CreateNoWindow = true;
                process.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
                process.StartInfo.Arguments = Configuration.DecompileOptions + " " + Configuration.InputDir + "\\" + dllName + " /OUT=" + Configuration.DecompiledDir + "\\" + dllName + Configuration.decompileExtension;
                process.Start();
                process.WaitForExit();
                if (process.ExitCode != 0)
                    throw new Exception("Error while decompiling " + dllName);
            }
            catch (Exception )
            {
                throw new Exception("Error while decompiling " + dllName);
            }
        }

        public static void Recompile(string dllName)
        {
            try
            {
                Process process = new Process();
                process.StartInfo.FileName = Configuration.ilasmLocation;
                process.StartInfo.CreateNoWindow = true;
                process.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
                process.StartInfo.Arguments = Configuration.CompileOptions + " /OUTPUT=" + Configuration.OutputDir + "\\" + dllName + " " + Configuration.DecompiledDir + "\\" + dllName + Configuration.decompileExtension;
                process.Start();
                process.WaitForExit();
                if (process.ExitCode != 0)
                    throw new Exception("Error while compiling " + dllName);
            }
            catch (Exception)
            {
                throw new Exception("Error while compiling " + dllName);
            }
        }

        public static void CopyFromGAC(string dllName, string dllFullPath)
        {
            try
            {
                File.Copy(dllFullPath, Configuration.InputDir + "\\" + dllName, true);
            }
            catch (Exception )
            {
                throw new Exception("Error while copying  " + dllName +" from the GAC");
            }
        }

        public static bool IsFileExists(string dllFullPath)
        {
            return File.Exists(dllFullPath);
        }

        public static void DeleteDirContent(string directory)
        {
            string[] files = Directory.GetFiles(directory);
            try
            {
                foreach (string s in files)
                {
                    File.Delete(s);
                }
                string[] dirs = Directory.GetDirectories(directory);
                foreach (string d in dirs)
                {
                    Directory.Delete(d, true);
                }
            }
            catch (Exception )
            {
                throw new Exception("Error while deleting directory content of " + directory);
            }
        }

        public static string RemoveDLLExtension(string dllName)
        {
            return dllName.Remove(dllName.Length - 4); //remove ".dll"
        }


        public static void GenerateDeployer(string dllName, string dllLocation, string nativeImageLocation)
        {            
            try
            {
                StreamWriter writer = new StreamWriter(Configuration.deployFileName);
                writer.WriteLine("@echo off");
                writer.WriteLine("echo .NET-Sploit Auto-Generated batch file for deploying modified assemblies");
                writer.WriteLine("echo.");
                writer.WriteLine("echo Deploying " + dllName + " to " + dllLocation);
                writer.WriteLine("echo.");
                writer.WriteLine("copy /y " + Configuration.OutputDir + "\\" + dllName + " " + dllLocation + "\\" + dllName);
                writer.WriteLine("echo Disabling NGEN for " + dllName);
                writer.WriteLine("echo.");
                writer.WriteLine(Configuration.ngenLocation + " uninstall " + RemoveDLLExtension(dllName) +" 2 > NUL");
                writer.WriteLine("echo Deleting native image from " + nativeImageLocation);
                writer.WriteLine("echo.");
                writer.WriteLine("rd /s /q " + nativeImageLocation + " 2>NUL");
                writer.Close();

                //generate undeployer
                writer = new StreamWriter(Configuration.undeployFileName);
                writer.WriteLine("@echo off");
                writer.WriteLine("echo .NET-Sploit Auto-Generated batch file for undeploying (restoring) modified assemblies");
                writer.WriteLine("echo.");
                writer.WriteLine("echo Undeploying " + dllName + " from " + dllLocation);
                writer.WriteLine("echo.");
                writer.WriteLine("copy /y " + Configuration.InputDir + "\\" + dllName + " " + dllLocation + "\\" + dllName);
                writer.Close();
            }
            catch (Exception)
            {
                throw new Exception("Error while generating deployer batch files");
            }
        }
    }
}

